<template>
  <div class="hello">
    <Header />
    <div class="container mrgnbtm">
          <div class="row">
            <div class="col-md-8">
                <CreateUser @createUser="userCreate($event)" />
            </div>
            <div class="col-md-4">
                <DisplayBoard :numberOfUsers="numberOfUsers" @getAllUsers="getAllUsers()" :numberOfMedias="numberOfMedias" @getAllMedias="getAllMedias()" />
            </div>
          </div>
          <div class="row">
            <div class="col-12">
              <CreateMedia @createMedia="mediaCreate($event)" />
            </div>
          </div>
    </div>
    <div class="row mrgnbtm">
        <Users v-if="users.length > 0" :users="users" />
    </div>
    <div class="row mrgnbtm">
        <Medias v-if="medias.length > 0" :medias="medias" />
    </div>
    
  </div>
</template>

<script>
import Header from './Header.vue'
import CreateUser from './CreateUser.vue'
import CreateMedia from './CreateMedia.vue'
import DisplayBoard from './DisplayBoard.vue'
import Users from './Users.vue'
import Medias from './Medias.vue'
import { getAllUsers, createUser } from '../services/UserService'
import { getAllMedias, createMedia  } from '../services/MediaService'

export default {
  name: 'Dashboard',
  components: {
    Header,
    CreateUser,
    CreateMedia,
    DisplayBoard,
    Users,
    Medias
  },
  data() {
      return {
          users: [],
          numberOfUsers: 0,
          medias: [],
          numberOfMedias: 0
      }
  },
  methods: {
    getAllUsers() {
      getAllUsers().then(response => {
        console.log(response)
        this.users = response
        this.numberOfUsers = this.users.length
      })
    },
    userCreate(data) {
      console.log('data:::', data)
      createUser(data).then(response => {
        console.log(response);
        this.getAllUsers();
      });
    },
    getAllMedias(){
      getAllMedias().then(response => {
        console.log(response["hydra:member"])
        this.medias = response["hydra:member"]
        this.numberOfMedias = this.medias.length
      })
    },
    mediaCreate(data) {
      console.log('data:::', data)
      createMedia(data).then(response => {
        console.log(response);
        this.getAllMedias();
      });
    }
  },
  mounted () {
    this.getAllUsers();
  }
}
</script>